package com.andreums.culturarocafort.activities.messages;

import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;

import com.andreums.culturarocafort.R;
import com.andreums.culturarocafort.database.GCMDatabaseHandler;
import com.andreums.culturarocafort.models.GCMMessage;
import com.andreums.culturarocafort.util.DataStorage;
import com.andreums.culturarocafort.util.DateUtils;



import org.apache.commons.lang3.StringEscapeUtils;

public class MessageViewerActivity extends ActionBarActivity {

    private GCMMessage message;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.message_viewer_activity);
        this.message = this.getEventFromIntent();

        this.setInterface();
        this.setActionbar();

    }

    private void setInterface() {

        TextView title    = (TextView) findViewById(R.id.message_title);
        TextView date     = (TextView) findViewById(R.id.message_date);
        TextView contents = (TextView) findViewById(R.id.message_contents);

        if (this.message!=null) {
            title.setText(StringEscapeUtils.unescapeHtml4(this.message.getTitle()));
            contents.setText(StringEscapeUtils.unescapeHtml4(this.message.getMessage()));
            date.setText(DateUtils.convertToPostDate(this.message.getReceived()));
        }
    }


    private void setActionbar() {
        getSupportActionBar().setIcon(R.drawable.ic_launcher);
        getSupportActionBar().setHomeButtonEnabled(true);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setTitle(StringEscapeUtils.unescapeHtml4(this.message.getTitle()));
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()) {

            case android.R.id.home:
                this.finish();
                return true;

            default:
                break;
        }

        return true;
    }


    private GCMMessage getEventFromIntent() {
        GCMMessage message;
        int id                       = DataStorage.getGcmMessageToView();
        GCMDatabaseHandler handler   = GCMDatabaseHandler.getInstance(this.getApplicationContext());
        message                      = handler.getMessage(id);
        handler.markMessageAsReaded(id);
        DataStorage.setGcmMessageToView(-1);
        return message;
    }


}
