package com.andreums.culturarocafort.adapters.events;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.andreums.culturarocafort.R;
import com.andreums.culturarocafort.models.EventCategory;

import org.apache.commons.lang3.StringEscapeUtils;

import java.util.ArrayList;

public class EventCategoryAdapter extends ArrayAdapter<EventCategory> {
    private ArrayList<EventCategory> objects = new ArrayList<EventCategory>();
    private Context context;


    public EventCategoryAdapter(Context itemListFragment, int textviewid, ArrayList<EventCategory> objects) {
        super(itemListFragment, textviewid, objects);
        this.context = itemListFragment;
        this.objects = objects;
    }

    @Override
    public int getCount() {
        return ((null != objects) ? objects.size() : 0);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public EventCategory getItem(int position) {
        return ((null != objects) ? objects.get(position) : null);
    }

    public View getView(int position, View view, ViewGroup parent) {
        ViewHolder holder;
        EventCategory data = objects.get(position);

        if (view==null) {
            LayoutInflater vi = (LayoutInflater) getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            view              = vi.inflate(R.layout.event_category_item,null);
            holder            = new ViewHolder();
            holder.title      = (TextView) view.findViewById(R.id.event_category_title);
            holder.count      = (TextView) view.findViewById(R.id.event_category_count);

            view.setTag(holder);
        }

        else {
            holder = (ViewHolder) view.getTag();
        }

        if (data!=null) {
            int count      = data.getPost_count();
            holder.title.setText(StringEscapeUtils.unescapeHtml4(data.getTitle()));
            holder.count.setText(String.valueOf(count));
        }
        return view;
    }

    private static class ViewHolder {
        TextView title;
        TextView count;
    }


}