package com.andreums.culturarocafort.adapters.main;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.andreums.culturarocafort.R;
import com.andreums.culturarocafort.models.SideMenuItem;

import org.apache.commons.lang3.StringEscapeUtils;

import java.util.ArrayList;

public class SideMenuAdapter extends ArrayAdapter<SideMenuItem> {
    private ArrayList<SideMenuItem> objects = new ArrayList<SideMenuItem>();


    public SideMenuAdapter(Context itemListFragment, int textviewid, ArrayList<SideMenuItem> objects) {
        super(itemListFragment, textviewid, objects);
        this.objects = objects;
    }

    @Override
    public int getCount() {
        return ((null != objects) ? objects.size() : 0);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public SideMenuItem getItem(int position) {
        return ((null != objects) ? objects.get(position) : null);
    }

    public View getView(int position, View view, ViewGroup parent) {
        ViewHolder holder;
        SideMenuItem data = objects.get(position);

        if (view==null) {
            LayoutInflater vi = (LayoutInflater) getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            view              = vi.inflate(R.layout.side_menu_item,null);
            holder            = new ViewHolder();
            holder.title      = (TextView) view.findViewById(R.id.menu_item_title);
            holder.image      = (ImageView) view.findViewById(R.id.menu_item_image);

            view.setTag(holder);
        }

        else {
            holder = (ViewHolder) view.getTag();
        }

        if (data!=null) {
            holder.title.setText(StringEscapeUtils.unescapeHtml4(data.getTitle()));
            holder.image.setImageDrawable(this.getContext().getResources().getDrawable(data.getImage()));
        }
        return view;
    }

    private static class ViewHolder {
        TextView title;
        ImageView image;
    }


}