package com.andreums.culturarocafort.adapters.photos;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;

import com.andreums.culturarocafort.R;
import com.andreums.culturarocafort.models.FacebookPhoto;
import com.squareup.picasso.Picasso;

import java.util.ArrayList;

public class FacebookPhotoAlbumsAdapter extends ArrayAdapter<FacebookPhoto> {

    private Context context;

    private ArrayList<FacebookPhoto> objects = new ArrayList<FacebookPhoto>();


    public FacebookPhotoAlbumsAdapter(Context itemListFragment, int textviewid, ArrayList<FacebookPhoto> objects) {
        super(itemListFragment, textviewid, objects);
        this.objects = objects;
        this.context = itemListFragment;
    }


    public int getCount() {
        return this.objects.size();
    }


    public FacebookPhoto getItem(int position) {
        return this.objects.get(position);
    }

    public long getItemId(int position) {
        return position;
    }

    public View getView(int position, View view, ViewGroup parent) {

        ViewHolder holder;
        String url          = "";
        FacebookPhoto image = this.getItem(position);
        url                 = image.getImage();


        if (view==null) {
            LayoutInflater vi = (LayoutInflater) getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            view              = vi.inflate(R.layout.photo_item,null);

            holder            = new ViewHolder();
            holder.image      = (ImageView) view.findViewById(R.id.photo_image);

            view.setTag(holder);

        }
        else {
            holder = (ViewHolder) view.getTag();
        }
        if ( (url!=null) && (url.length()>0) ) {
            Picasso.with(this.getContext()).load(url).placeholder(R.drawable.ic_launcher).resize(150,150).error(R.drawable.ic_launcher).into(holder.image);
        }
        return view;
    }


    private static class ViewHolder {
        ImageView image;

    }
}