package com.andreums.culturarocafort.adapters.photos;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.andreums.culturarocafort.R;
import com.andreums.culturarocafort.models.FacebookPhoto;
import com.squareup.picasso.Picasso;

import org.apache.commons.lang3.StringEscapeUtils;

import java.util.ArrayList;

public class FacebookPhotosAdapter extends ArrayAdapter<FacebookPhoto> {

    private Context context;
    private ArrayList<FacebookPhoto> objects = new ArrayList<FacebookPhoto>();

    public FacebookPhotosAdapter(Context itemListFragment, int textviewid, ArrayList<FacebookPhoto> objects) {
        super(itemListFragment, textviewid, objects);
        this.objects = objects;
    }

    public int getCount() {
        return this.objects.size();
    }

    public FacebookPhoto getItem(int position) {
        return this.objects.get(position);
    }

    public long getItemId(int position) {
        return position;
    }


    public View getView(int position, View view, ViewGroup parent) {

        ViewHolder holder;
        FacebookPhoto photo = this.getItem(position);

        if (view==null) {
            LayoutInflater vi = (LayoutInflater) getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            view = vi.inflate(R.layout.album_item,null);

            holder = new ViewHolder();
            holder.title = (TextView) view.findViewById(R.id.album_title);
            holder.image = (ImageView) view.findViewById(R.id.album_image);


            view.setTag(holder);

        }
        else {
            holder = (ViewHolder) view.getTag();
        }

        holder.title.setText(StringEscapeUtils.unescapeHtml4(photo.getName()));
        if (photo.getImage()!=null && photo.getImage().length()>0) {
            Picasso.with(this.getContext()).load(photo.getImage()).placeholder(R.drawable.ic_launcher).resize(150,150).error(R.drawable.ic_launcher).into(holder.image);
        }

        return view;

    }


    private static class ViewHolder {
        TextView title;
        ImageView image;
    }
}