package com.andreums.culturarocafort.adapters.photos;


import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Gallery;
import android.widget.ImageView;

import com.andreums.culturarocafort.R;
import com.andreums.culturarocafort.models.FacebookPhoto;
import com.squareup.picasso.Picasso;

import java.util.ArrayList;


public class GalleryImageAdapter extends ArrayAdapter<FacebookPhoto> {

    private Context context;
    private ArrayList<FacebookPhoto> objects;

    public GalleryImageAdapter(Context itemListFragment, int textviewid, ArrayList<FacebookPhoto> objects) {
        super(itemListFragment, textviewid, objects);
        this.objects = objects;
        this.context = itemListFragment;
    }

    @Override
    public int getCount() {
        return this.objects.size();
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public FacebookPhoto getItem(int position) {
        return ((null != objects) ? objects.get(position) : null);
    }
    @Override
    public View getView(int position, View view, ViewGroup parent) {
        FacebookPhoto image = this.getItem(position);

        ViewHolder holder = new ViewHolder();

        if (view==null && image!=null) {
            LayoutInflater vi = (LayoutInflater) this.context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            view = vi.inflate(R.layout.post_item,null);

            holder.image      = new ImageView(this.context);
            holder.image.setLayoutParams(new Gallery.LayoutParams(150,150));
            holder.image.setScaleType(ImageView.ScaleType.FIT_CENTER);
            Picasso.with(this.context).load(image.getImage()).placeholder(R.drawable.ic_launcher).resize(150,150).error(R.drawable.ic_launcher).resize(150,150).into(holder.image);
            view.setTag(holder);

        }
        else {
            Picasso.with(this.context).load(image.getImage()).placeholder(R.drawable.ic_launcher).resize(150,150).error(R.drawable.ic_launcher).resize(150,150).into(holder.image);
            holder = (ViewHolder) view.getTag();
        }
        return holder.image;
    }

    private static class ViewHolder {
        ImageView image;
    }

}