package com.andreums.culturarocafort.database;

import android.content.Context;
import android.database.Cursor;
import android.database.DatabaseUtils;

import com.andreums.culturarocafort.models.LatLng;

public class GeocoderDatabaseHandler {

    private DatabaseHandler db;
    private static GeocoderDatabaseHandler instance;

    public static GeocoderDatabaseHandler getInstance(Context context) {
        if (instance == null) {
            instance = new GeocoderDatabaseHandler(context);
        }
        return instance;
    }


    public GeocoderDatabaseHandler(Context context) {
        this.db      = DatabaseHandler.getInstance(context);
    }

    public void clearPositions() {
        try {
            this.db.exec("DELETE FROM geocoder_cache");
        }
        catch (Exception ex) { }
    }

    public void insertAddress(String address, LatLng position) {
        try {
            address      = DatabaseUtils.sqlEscapeString(address).replace("'","");
            String query = "INSERT INTO geocoder_cache (address,lat,lng) VALUES ('"+address+"','"+position.latitude()+"','"+position.longitude()+"' )";
            this.db.exec(query);
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }


    public LatLng getPosition(String address) {
        address       = DatabaseUtils.sqlEscapeString(address).replace("'", "");
        LatLng result = new LatLng(0,0);
        try {
            String query  = "SELECT * FROM geocoder_cache WHERE address='"+address+"' ;";
            Cursor cursor = this.db.query(query);
            if (cursor != null) {
                if (cursor.moveToFirst()) {
                    String lat = cursor.getString(1);
                    String lng = cursor.getString(2);

                    if (lat.length()>0 && lng.length()>0) {
                        result = new LatLng(Double.parseDouble(lat),Double.parseDouble(lng));
                    }
                }
            }
            cursor.close();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        return result;
    }


    public boolean hasPosition(String address) {
        address = DatabaseUtils.sqlEscapeString(address).replace("'", "");
        try {
            String query  = "SELECT * FROM geocoder_cache WHERE address='"+address+"' ;";
            Cursor cursor = this.db.query(query);

            if (cursor.getCount()>0) {
                cursor.close();
                return true;
            }
            else {
                cursor.close();
                return false;
            }
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        return false;
    }
}
