package com.andreums.culturarocafort.dialogs;


import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.andreums.culturarocafort.R;
import com.andreums.culturarocafort.activities.messages.MessagesActivity;
import com.andreums.culturarocafort.database.GCMDatabaseHandler;
import com.andreums.culturarocafort.models.GCMMessage;
import com.andreums.culturarocafort.util.DataStorage;
import com.andreums.culturarocafort.util.DateUtils;

public class NotificationDialog extends DialogFragment {

    private static int id;
    private Context context;


    public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);
    }



    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle icicle){
        View view = inflater.inflate(R.layout.notification_dialog, container, false);

        this.context = getActivity().getApplicationContext();

        final GCMDatabaseHandler handler = GCMDatabaseHandler.getInstance(getActivity().getApplicationContext());
        final GCMMessage message         = handler.getMessage(NotificationDialog.id);

        if (message!=null) {

            this.getDialog().setTitle(message.getTitle());

            TextView title = (TextView) view.findViewById(R.id.notification_title);
            title.setText(message.getTitle());

            TextView date = (TextView) view.findViewById(R.id.notification_date);
            date.setText(DateUtils.convertToNotificationDate(message.getReceived()));

            TextView text = (TextView) view.findViewById(R.id.notification_message);
            text.setText(message.getMessage());

            Button ok            = (Button) view.findViewById(R.id.notification_button_ok);
            Button delete        = (Button) view.findViewById(R.id.notification_button_delete);
            Button notifications = (Button) view.findViewById(R.id.notification_button_notifications);


            ok.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    NotificationDialog.this.dismiss();
                    DataStorage.setGcmMessageId(-1);
                }
            });

            delete.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    handler.deleteMessage(message.getId());
                    NotificationDialog.this.dismiss();
                    Toast.makeText(NotificationDialog.this.context, "Mensaje borrado", Toast.LENGTH_LONG).show();
                    DataStorage.setGcmMessageId(-1);
                }
            });


            notifications.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    NotificationDialog.this.dismiss();
                    Intent intent = new Intent (NotificationDialog.this.context, MessagesActivity.class);
                    startActivity(intent);
                    DataStorage.setGcmMessageId(-1);
                }
            });
        }
        return view;
    }

    public NotificationDialog setMessageId(int id) {
        NotificationDialog.id = id;
        return this;
    }
}