package com.andreums.culturarocafort.dialogs;


import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.Toast;

import com.andreums.culturarocafort.R;
import com.andreums.culturarocafort.util.Preferences;

public class RateAppDialog extends DialogFragment {

    public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle icicle){
        View view = inflater.inflate(R.layout.rate_app_dialog, container, false);
        this.getDialog().setTitle(getString(R.string.rate_dialog_title));

        Button ok     = (Button) view.findViewById(R.id.rate_button_ok);
        Button ko     = (Button) view.findViewById(R.id.rate_button_ko);
        Button remind = (Button) view.findViewById(R.id.rate_button_remind);


        ok.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent a = new Intent(Intent.ACTION_VIEW, Uri.parse("market://details?id=com.delegatelabs.rocafortapp"));
                if ( (!RateAppDialog.this.startGooglePlayIntent(a))==false ) {
                    a.setData(Uri.parse("https://play.google.com/store/apps/details?id=com.delegatelabs.rocafortapp"));
                    if ( (RateAppDialog.this.startGooglePlayIntent(a))==false ) {
                        Toast.makeText(RateAppDialog.this.getActivity().getApplicationContext(),RateAppDialog.this.getResources().getString(R.string.rate_dialog_noplay), Toast.LENGTH_SHORT).show();
                    }

                }
                RateAppDialog.this.dismiss();
            }
        });

        remind.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                RateAppDialog.this.dismiss();
            }
        });


        ko.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Preferences prefs = Preferences.getInstance(RateAppDialog.this.getActivity().getApplicationContext());
                prefs.setValueBoolean("dontshowagain",true);
                RateAppDialog.this.dismiss();
            }
        });

        return view;
    }


    private boolean startGooglePlayIntent (Intent aIntent) {
        try {
            startActivity(aIntent);
            return true;
        }
        catch (ActivityNotFoundException e) {
            return false;
        }
    }


}