package com.andreums.culturarocafort.fragments.other;

import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBar;
import android.support.v7.app.ActionBarActivity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;

import com.andreums.culturarocafort.Constants;
import com.andreums.culturarocafort.R;
import com.andreums.culturarocafort.activities.contact.PrivacyActivity;


import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ContactFragment extends Fragment {

    private ProgressDialog progressDialog;

    @Override
    public void onResume() {
        super.onResume();
        this.setActionbar();
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,Bundle savedInstanceState) {
        this.setHasOptionsMenu(true);
        this.setActionbar();

        View view = inflater.inflate(R.layout.contact_activity,container, false);

        Button lopd = (Button) view.findViewById(R.id.contact_button_lopd);
        lopd.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ContactFragment.this.viewLOPD(v);
            }
        });


        Button send = (Button) view.findViewById(R.id.contact_button_send);
        send.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ContactFragment.this.send(v);
            }
        });


        Button delete = (Button) view.findViewById(R.id.contact_button_delete);
        delete.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ContactFragment.this.deleteContents(v);
            }
        });

        return view;
    }


    private void setActionbar() {
        ActionBar bar = ( (ActionBarActivity) getActivity()).getSupportActionBar();
        bar.setIcon(R.drawable.ic_launcher);
        bar.setHomeButtonEnabled(true);
        bar.setDisplayHomeAsUpEnabled(true);
        bar.setTitle(getResources().getString(R.string.contact_title));
    }


    public void send(View v) {

        CheckBox  conditions = (CheckBox) this.getView().findViewById(R.id.contact_conditions);
        if (conditions.isChecked()) {

            String  name    = "";
            String  email   = "";
            String subject  = "";
            String message  = "";
            String msg      = "";

            EditText  ename    = (EditText) this.getView().findViewById(R.id.contact_name);
            EditText  eemail   = (EditText) this.getView().findViewById(R.id.contact_email);
            EditText  esubject = (EditText) this.getView().findViewById(R.id.contact_subject);
            EditText  emessage = (EditText) this.getView().findViewById(R.id.contact_text);


            name    = ename.getText().toString();
            email   = eemail.getText().toString();
            subject = esubject.getText().toString();
            message = emessage.getText().toString();

            if (name.equals("") || email.equals("") || subject.equals("") || message.equals("") || !this.isValidEmail(email) ) {
                this.showAlertDialog();
                return;
            }
            this.progressDialog = ProgressDialog.show(this.getActivity(), getResources().getString(R.string.contact_dialog_email_title), getResources().getString(R.string.contact_dialog_email_message), true, false);
            String[] values     = new String[] { name,email,subject,message};
            new SendEmailTask().execute(values);
            return;

        }
        else {
            this.showAlertDialog();
            return;
        }
    }

    public void deleteContents(View v) {
        EditText  ename    = (EditText) this.getView().findViewById(R.id.contact_name);
        EditText  eemail   = (EditText) this.getView().findViewById(R.id.contact_email);
        EditText  esubject = (EditText) this.getView().findViewById(R.id.contact_subject);
        EditText  emessage = (EditText) this.getView().findViewById(R.id.contact_text);

        ename.setText("");
        eemail.setText("");
        esubject.setText("");
        emessage.setText("");
    }

    private void showAlertDialog() {
        AlertDialog alertDialog = new AlertDialog.Builder(this.getActivity()).create();
        alertDialog.setTitle(getResources().getString(R.string.contact_activity_alert_title));
        alertDialog.setMessage(getResources().getString(R.string.contact_activity_alert_message));
        alertDialog.setButton(getResources().getString(R.string.contact_activity_alert_accept), new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            }
        });
        alertDialog.show();
    }


    private void showAlertDialogKO() {
        AlertDialog alertDialog = new AlertDialog.Builder(this.getActivity()).create();
        alertDialog.setTitle(getResources().getString(R.string.contact_activity_alert_title_ko));
        alertDialog.setMessage(getResources().getString(R.string.contact_activity_alert_message_ko));
        alertDialog.setButton(getResources().getString(R.string.contact_activity_alert_accept), new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            }
        });
        alertDialog.show();
    }

    private void showAlertDialogOK() {
        AlertDialog alertDialog = new AlertDialog.Builder(this.getActivity()).create();
        alertDialog.setTitle(getResources().getString(R.string.contact_activity_alert_title_ok));
        alertDialog.setMessage(getResources().getString(R.string.contact_activity_alert_message_ok));
        alertDialog.setButton(getResources().getString(R.string.contact_activity_alert_accept), new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {

            }
        });
        alertDialog.show();
    }

    public void viewLOPD(View v) {
        Intent intent = new Intent(this.getActivity(),PrivacyActivity.class);
        startActivity(intent);
    }

    public void cancel(View v) {

    }

    @Override
    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
        //inflater.inflate(R.menu.menu_main, menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {

            case android.R.id.home:

                return true;

            default:
                break;
        }

        return true;
    }

    private class SendEmailTask extends AsyncTask<String, Void, Boolean> {
        @Override
        protected Boolean doInBackground(String... params) {

            String name           = params[0];
            String email          = params[1];
            String subject        = params[2];
            String message        = params[3];
            HttpClient httpclient = new DefaultHttpClient();
            HttpPost httppost     = new HttpPost(Constants.contact_url);

            try {
                List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(2);
                nameValuePairs.add(new BasicNameValuePair("name",name));
                nameValuePairs.add(new BasicNameValuePair("email",email));
                nameValuePairs.add(new BasicNameValuePair("subject",subject));
                nameValuePairs.add(new BasicNameValuePair("message",message));
                httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));

                HttpResponse response = httpclient.execute(httppost);
                HttpEntity entity     = response.getEntity();
                String result         = EntityUtils.toString(entity, "UTF-8");
                if (result.equals("true") ) {
                    return true;
                }
                else {
                    return false;
                }

            }
            catch (ClientProtocolException e) {

            }
            catch (IOException e) {

            }
            return false;
        }

        @Override
        public void onPostExecute(Boolean result) {
            ContactFragment.this.progressDialog.dismiss();
            if (result==true) {
                ContactFragment.this.showAlertDialogOK();
            }
            else {
                ContactFragment.this.showAlertDialogKO();
            }
        }
    }



    private boolean isValidEmail(String email)    {
        if (email.equals("")) {
            return false;
        }
        String expression = "^[\\w\\.-]+@([\\w\\-]+\\.)+[A-Z]{2,4}$";
        CharSequence inputStr = email;
        Pattern pattern = Pattern.compile(expression, Pattern.CASE_INSENSITIVE);
        Matcher matcher = pattern.matcher(inputStr);
        if (matcher.matches()) {
            return true;
        }
        return false;
    }







}