package com.andreums.culturarocafort.fragments.other;

import android.graphics.Bitmap;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import com.andreums.culturarocafort.R;
import com.andreums.culturarocafort.util.DataStorage;


public class WebViewFragment extends Fragment {

    private static WebView webView;
    @Override
    public void onCreate (Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setHasOptionsMenu(true);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.two_panel_browser, container, false);

        WebView webView = (WebView) view.findViewById(R.id.two_panel_webview);
        webView.loadUrl("http://cultura.rocafort.es");

        webView.setWebViewClient(new WebViewClient() {

            @Override
            public void onPageStarted (WebView view, String url, Bitmap favicon) {
                WebViewFragment.this.startProgressBarAnimation();
            }

            @Override
            public void onPageFinished(WebView view, String url) {
                WebViewFragment.this.stopProgressBarAnimation();
            }
        });

        WebViewFragment.webView = webView;
        return view;
    }

    public static WebView getWebView() {

        return WebViewFragment.webView;
    }

    public void startProgressBarAnimation() {
        DataStorage.pushProcess();
        this.getActivity().setProgressBarIndeterminateVisibility(true);

    }

    public void stopProgressBarAnimation() {
        DataStorage.popProcess();
        this.getActivity().setProgressBarIndeterminateVisibility(false);
    }



}