package com.andreums.culturarocafort.models;
import android.text.TextUtils;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;


@JsonIgnoreProperties(ignoreUnknown = true)
public class Event {


    private int id;
    private String title;
    private String url;
    private String date;
    private String excerpt;
    private String content;
    private String image;
    private String thumbnail;
    private String venue;
    private String address;
    private String price;
    private String start_date;
    private String end_date;

    @JsonProperty("taxonomy_tribe_events_cat")
    private ArrayList<EventCategory> categories;




    public Event() {
        this.categories = new ArrayList<EventCategory>();
    }

    public String toSQL() {
        String address     = this.unescape(TextUtils.htmlEncode(this.getAddress()));
        String title       = this.unescape(TextUtils.htmlEncode(this.getTitle()));
        String description = TextUtils.htmlEncode(this.getExcerpt());
        String content     = TextUtils.htmlEncode(this.getContent());
        String query = "INSERT INTO event (id,title,url,date,excerpt,content,image,thumbnail,venue,address,price,start_date,end_date) VALUES ('"+ this.getId() +"','"+title+"','"+ this.getUrl() +"','"+ this.getDate() +"','"+description+"','"+content+"','"+ this.getImage() +"','"+ this.getThumbnail() +"','"+ this.getVenue() +"','"+address+"','"+ this.getPrice() +"','"+ this.getStart_date() +"','"+ this.getEnd_date() +"');" ;

        return query;
    }

    public Event(int id, String title, String link, String date, String description, String content, String image, String thumb, String venue,String address, String price, String start_date,String end_date) {
        this.setId(id);
        this.setTitle(title);
        this.setUrl(link);
        this.setDate(date);
        this.setExcerpt(description);
        this.setContent(content);
        this.setImage(image);
        this.setThumbnail(thumb);
        this.setVenue(venue);
        this.setAddress(address);
        this.setPrice(price);
        this.setStart_date(start_date);
        this.setEnd_date(end_date);
    }

    public ArrayList<EventCategory> getCategories() {
        return this.categories;
    }



    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public String getDate() {
        return date;
    }

    public void setDate(String date) {
        this.date = date;
    }

    String getExcerpt() {
        return excerpt;
    }

    public void setExcerpt(String excerpt) {
        this.excerpt = excerpt;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public String getContent() {
        return this.content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public String getVenue() {
        return venue;
    }

    public void setVenue(String venue) {
        this.venue = venue;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address)  {
        this.address = address;
    }

    public String getPrice() {
        return price;
    }

    public void setPrice(String price) {
        this.price = price;
    }

    public String getStart_date() {
        return start_date;
    }

    public void setStart_date(String start_date) {
        this.start_date = start_date;
    }

    public String getEnd_date() {
        return end_date;
    }

    public void setEnd_date(String end_date) {
        this.end_date = end_date;
    }

    public String getThumbnail() {
        return thumbnail;
    }

    public void setThumbnail(String thumbnail) {
        this.thumbnail = thumbnail;
    }


    private String unescape (String s)  {
        while (true)   {
            int n=s.indexOf("&#");
            if (n<0) break;
            int m=s.indexOf(";",n+2);
            if (m<0) break;
            try
            {
                s=s.substring(0,n)+(char)(Integer.parseInt(s.substring(n+2,m)))+
                        s.substring(m+1);
            }
            catch (Exception e)
            {
                return s;
            }
        }
        s=s.replace("&quot;","\"");
        s=s.replace("&lt;","<");
        s=s.replace("&gt;",">");
        s=s.replace("&amp;","&");
        return s;
    }

    public Date getStartAsDate() {
        Date date            = null;
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        try {
            date = sdf.parse(this.getStart_date());
        }catch(Exception ex){
            ex.printStackTrace();
        }
        return date;
    }

    public Date getEndAsDate() {
        Date date            = null;
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        try {
            date = sdf.parse(this.getEnd_date());
        }catch(Exception ex){
            ex.printStackTrace();
        }
        return date;
    }

    public void setCategories(ArrayList<EventCategory> categories) {
        this.categories = categories;
    }
}