package com.andreums.culturarocafort.models;

import android.database.DatabaseUtils;
import android.text.TextUtils;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.ArrayList;


@JsonIgnoreProperties(ignoreUnknown = true)
public class Post {

    private int id;
    private String title;
    private String url;
    private String date;
    private String excerpt;
    private String content;
    private String image;
    private String thumbnail;
    private String status;

    @JsonProperty("categories")
    private ArrayList<PostCategory> categories;


    public Post() {
        this.categories = new ArrayList<PostCategory>();
    }



    public String toSQL() {
        String description = DatabaseUtils.sqlEscapeString(this.getExcerpt()).replace("'","");
        String content     = TextUtils.htmlEncode(this.content);
        String query = "INSERT INTO post (id,title,url,date,description,content,image,thumbnail) VALUES ('"+this.id+"','"+this.title+"','"+this.url +"','"+this.date+"','"+description+"','"+content+"','"+this.image+"','"+this.thumbnail +"')";
        return query;
    }

    public Post(int id, String title, String url, String date, String excerpt, String content, String image, String thumbnail) {
        this.id = id;
        this.title = title;
        this.url = url;
        this.date = date;
        this.excerpt = excerpt;
        this.content = content;
        this.image = image;
        this.thumbnail = thumbnail;
    }

    public ArrayList<PostCategory> getCategories() {
        return this.categories;
    }

    public void setCategories(ArrayList<PostCategory> categories) {
        this.categories = categories;
    }


    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public String getDate() {
        return date;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public String getExcerpt() {
        return this.excerpt;
    }

    public void setExcerpt(String excerpt) {
        this.excerpt = excerpt;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public String getContent() {
        return this.content;
    }

    public void setContent(String content) {
        this.content = content;
    }


    public void setThumbnail(String thumbnail) {
        this.thumbnail = thumbnail;
    }

    public String getThumbnail() {
        return this.thumbnail;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }
}