package com.andreums.culturarocafort.models;


import android.text.TextUtils;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;

@JsonIgnoreProperties(ignoreUnknown = true)
public class PostCategory {

    private int id;
    private String slug;
    private String title;
    private String description;
    private int parent;

    @JsonProperty("post_count")
    private int postCount;

    public PostCategory() { }

    public PostCategory (int id,String title,String slug,String description,int parent,int post_count) {
        this.id = id;
        this.slug = slug;
        this.title = title;
        this.description = description;
        this.parent = parent;
        this.postCount = post_count;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getSlug() {
        return slug;
    }

    public void setSlug(String slug) {
        this.slug = slug;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public int getParent() {
        return parent;
    }

    public void setParent(int parent) {
        this.parent = parent;
    }

    public int getPostCount() {
        return postCount;
    }

    public void setPostCount(int postCount) {
        this.postCount = postCount;
    }

    public String toSQL() {
        String description = TextUtils.htmlEncode(this.getDescription());
        String query = "INSERT INTO post_category (id,title,slug,description,parent) VALUES ('"+this.id+"','"+this.title+"','"+this.slug+"','"+description+"','"+this.parent+"')";
        return query;
    }

}
