package com.andreums.culturarocafort.models;

import android.content.Context;
import android.database.DatabaseUtils;

import com.andreums.culturarocafort.database.VideosDatabaseHandler;

import java.util.ArrayList;

public class VideoPlayList {


    private String id;
    private String title;
    private String description;
    private String url;
    private String published;
    private String thumbnail;


    public String toSQL() {
        String description = DatabaseUtils.sqlEscapeString(this.getDescription()).replace("'","");
        String title       = DatabaseUtils.sqlEscapeString(this.getTitle()).replace("'","");
        String query       = "INSERT INTO video_playlist (id,title,description,url,published,thumbnail) VALUES ('"+this.id+"','"+title+"','"+description+"','"+this.getUrl()+"','"+this.getPublished()+"','"+this.getThumbnail()+"')";
        return query;
    }

    public VideoPlayList() { }

    public VideoPlayList(String id, String title, String description, String url, String published, String thumbnail) {
        this.id          = id;
        this.title       = title;
        this.description = description;
        this.url         = url;
        this.published   = published;
        this.thumbnail   = thumbnail;
    }


    public String getTitle(){
        return title;
    }

    public String getUrl() {
        return url;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return this.description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public String getPublished() {
        return published;
    }

    public void setPublished(String published) {
        this.published = published;
    }

    public String getThumbnail() {
        return thumbnail;
    }

    public void setThumbnail(String thumbnail) {
        this.thumbnail = thumbnail;
    }

    public ArrayList<Video> getVideos(Context context) {
        VideosDatabaseHandler handler = VideosDatabaseHandler.getInstance(context);
        return handler.getPlayListVideos(this.id);
    }

    public int getVideoCount(Context context) {
        VideosDatabaseHandler handler = VideosDatabaseHandler.getInstance(context);
        int count                     = handler.getPlayListVideos(this.id).size();
        return count;
    }

}
