package com.andreums.culturarocafort.parsers;

import android.content.Context;

import com.andreums.culturarocafort.models.FacebookAlbum;
import com.andreums.culturarocafort.util.DateUtils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

public class FacebookAlbumJSONParser {


    private Context context;

    public FacebookAlbumJSONParser(Context context) {
        this.context = context;
    }

    public ArrayList<FacebookAlbum> parseJSON(String data) {
        ArrayList<FacebookAlbum> items = new ArrayList<FacebookAlbum>();

        if ( (data!=null) && (data.length()>=0) ) {
            JSONObject object;
            JSONArray array;
            try {
                object =  new JSONObject(data);
                array  = object.getJSONArray("data");
                if (array.length()>0) {
                    for (int i=0;i<array.length();i++) {
                        JSONObject aux = (JSONObject) array.get(i);
                        FacebookAlbum item = this.parsePost(aux);
                        items.add(item);
                    }
                }
            }
            catch (JSONException e) {
                e.printStackTrace();
            }
        }
        return items;
    }

    private FacebookAlbum parsePost(JSONObject aux) throws JSONException {
        FacebookAlbum item          = new FacebookAlbum();

        String id          = aux.getString("id");
        String title       = aux.getString("name");
        String link        = aux.getString("link");
        String created     = aux.getString("created_time");
        created            = DateUtils.convertToFacebookDate(created);


        String cover = "";
        String description = "";
        try {
            cover       = aux.getString("cover_photo");
            description = aux.getString("description");
        }
        catch (Exception ex) {}

        item.setId(id);
        item.setName(title);
        item.setDescription(description);
        item.setLink(link);
        item.setCreated_time(created);
        item.setCover(cover);
        return item;
    }



}