package com.andreums.culturarocafort.parsers;

import android.content.Context;

import com.andreums.culturarocafort.models.FacebookPhoto;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;


public class FacebookAlbumPhotoJSONParser {


    private Context context;

    public FacebookAlbumPhotoJSONParser(Context context) {
        this.context = context;
    }

    public ArrayList<FacebookPhoto> parseJSON(String data,String idAlbum) {
        ArrayList<FacebookPhoto> items = new ArrayList<FacebookPhoto>();

        if ( (data!=null) && (data.length()>=0) ) {
            JSONObject object;
            JSONArray array;
            try {
                object =  new JSONObject(data);
                array  = object.getJSONArray("data");
                if (array.length()>0) {
                    for (int i=0;i<array.length();i++) {
                        JSONObject aux = (JSONObject) array.get(i);
                        FacebookPhoto item = this.parsePost(aux,idAlbum);
                        items.add(item);
                    }
                }
            }
            catch (JSONException e) {
                e.printStackTrace();
            }
        }
        return items;
    }

    private FacebookPhoto parsePost(JSONObject aux,String idAlbum) throws JSONException {
        FacebookPhoto item          = new FacebookPhoto();

        String id          = aux.getString("id");
        String link        = aux.getString("link");
        String created     = aux.getString("created_time");
        String thumbnail   = aux.getString("picture");
        String image       = aux.getString("source");

        String name        = "";


        try {
            name        = aux.getString("name");
        }
        catch (Exception ex) {}

        item.setId(id);
        item.setName(name);
        item.setLink(link);
        item.setThumb(thumbnail);
        item.setImage(image);
        item.setAlbum_id(idAlbum);
        item.setCreated_time(created);
        return item;
    }



}