package com.andreums.culturarocafort.services;

import android.app.IntentService;
import android.content.Intent;

import com.andreums.culturarocafort.util.Connection;
import com.andreums.culturarocafort.util.DataStorage;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import twitter4j.Query;
import twitter4j.QueryResult;
import twitter4j.ResponseList;
import twitter4j.Status;
import twitter4j.Twitter;
import twitter4j.TwitterException;
import twitter4j.TwitterFactory;
import twitter4j.auth.OAuth2Token;
import twitter4j.conf.ConfigurationBuilder;

public class TwitterDownloaderService extends IntentService {

    private String url;

    public TwitterDownloaderService() {
        super("TwitterDownloaderService");
    }


    @Override
    protected void onHandleIntent(Intent intent) {

        ArrayList<Status> statuses  = new ArrayList<Status>();


        if ( Connection.getConnectionStatus(this.getApplicationContext()) ) {
            try {
                statuses = this.downloadData();
            }
            catch (TwitterException e) {
                e.printStackTrace();
            }
        }
        this.onServiceReturn(statuses);
    }

    // TODO: Constantes a fichero constants.java

    private ArrayList<Status> downloadData() throws TwitterException {
        ArrayList<Status> statuses   = new ArrayList<Status>();
        ConfigurationBuilder builder = new ConfigurationBuilder()
                .setDebugEnabled(true)
                .setOAuthConsumerKey("0ZhITccJt6iCuo1hXVKA3g")
                .setOAuthConsumerSecret("76Djj0SIOwiQ4OBUOL5F7VzDBBhPDpFQzlrhL02Jc")
                .setApplicationOnlyAuthEnabled(true);

        TwitterFactory twitterFactory = new TwitterFactory(builder.build());
        Twitter twitter               = twitterFactory.getInstance();
        OAuth2Token token             = twitter.getOAuth2Token();
        ResponseList<Status> timeline = twitter.getUserTimeline("culturarocafort");
        QueryResult result            = twitter.search(new Query("culturarocafort OR #festesRocafort2013 OR #rocafort").count(300));
        List<Status> status2          = result.getTweets();

        statuses.addAll(timeline);
        statuses.addAll(status2);

        Collections.sort(statuses);
        Collections.reverse(statuses);
        return statuses;
    }


    public void onServiceReturn(ArrayList<Status> data) {
        DataStorage.setTwitterData(data);
        Intent intentResponse = new Intent();
        intentResponse.setAction("com.andreums.culturarocafort.downloaded.twitter");
        sendBroadcast(intentResponse);
    }



}
