package com.andreums.culturarocafort.util;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class DateUtils {

    public static String convertFromInstagramDate(long seconds) {
        String result = "";
        Date date     = new Date(seconds*1000L);
        try {
            SimpleDateFormat outFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm 'h' ");
            result     = outFormat.format(date);
        }
        catch(Exception ex){
            ex.printStackTrace();
        }

        return result;
    }


    public static String convertToPostDate(String date) {
        Date parsedDate;
        String result             = "";
        SimpleDateFormat inFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        try {
            parsedDate = inFormat.parse(date);
            SimpleDateFormat outFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm 'h' ");
            result     = outFormat.format(parsedDate);
        }
        catch(Exception ex){
            ex.printStackTrace();
        }

        return result;
    }

    public static String convertToEventDate(String date) {
        Date parsedDate;
        String result             = "";
        SimpleDateFormat inFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        try {
            parsedDate = inFormat.parse(date);
            SimpleDateFormat outFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm 'h' ");
            result     = outFormat.format(parsedDate);
        }
        catch(Exception ex){
            ex.printStackTrace();
        }

        return result;
    }

    public static String convertToFacebookDate(String date) {
        Date parsedDate = null;
        SimpleDateFormat inFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ssZ");

        try {
            parsedDate = inFormat.parse(date);
        }
        catch(Exception ex){
            ex.printStackTrace();
        }
        SimpleDateFormat outFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return outFormat.format(parsedDate);
    }


    public static String convertFromFacebookDateToDatabaseTimesTamp(String date) {
        SimpleDateFormat inFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ssZ");
        Date parsedDate           = null;
        try {
            parsedDate = inFormat.parse(date);
        }
        catch(Exception ex){
            ex.printStackTrace();
        }
        SimpleDateFormat outFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return outFormat.format(parsedDate);
    }

    public static String convertFacebookPhotoAlbumDate(String date) {
        Date parsedDate           = null;
        try {
            SimpleDateFormat inFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            try {
                parsedDate = inFormat.parse(date);
            }
            catch(Exception ex){
                ex.printStackTrace();
            }
        }
        catch (Exception ex) {
            SimpleDateFormat inFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
            try {
                parsedDate = inFormat.parse(date);
            }
            catch(Exception ex2){
                ex2.printStackTrace();
            }
        }
        SimpleDateFormat outFormat = new SimpleDateFormat("dd/MM/yyyy");
        try {
            return outFormat.format(parsedDate);
        }
        catch(Exception ex3) {
            return date;
        }
    }



    public static String convertFromZuluDate(String date) {
        SimpleDateFormat inFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        Date parsedDate           = null;
        try {
            parsedDate = inFormat.parse(date);
        }
        catch(Exception ex){
            ex.printStackTrace();
        }
        SimpleDateFormat outFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm 'h' ");
        return outFormat.format(parsedDate);
    }

    public static String convertFromZuluDateToSQLiteFormat(String date) {
        SimpleDateFormat inFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        Date parsedDate           = null;
        try {
            parsedDate = inFormat.parse(date);
        }
        catch(Exception ex){
            ex.printStackTrace();
        }
        SimpleDateFormat outFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return outFormat.format(parsedDate);
    }




    public static String convertEventHeaderDateFormat(String date) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date testDate = null;
        try {
            testDate = sdf.parse(date);
        }
        catch(Exception ex){
            ex.printStackTrace();
        }
        SimpleDateFormat formatter = new SimpleDateFormat("EEEE dd/MM/yyyy");
        return formatter.format(testDate);
    }

    public static String getDate(String date) {
        String result        = "";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date testDate = null;
        try {
            testDate = sdf.parse(date);
        }catch(Exception ex){
            ex.printStackTrace();
        }
        SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy");
        return formatter.format(testDate);
    }


    public static String getHours(String date) {
        SimpleDateFormat inFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date parsedDate           = null;
        try {
            parsedDate = inFormat.parse(date);
        }
        catch(Exception ex){
            ex.printStackTrace();
        }
        SimpleDateFormat outFormat = new SimpleDateFormat("HH:mm 'h' ");
        return outFormat.format(parsedDate);
    }

    public static String getDateTimeNow() {
        Date date  =  new Date();
        SimpleDateFormat outFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return outFormat.format(date);
    }


    public static String getDateNow() {
        Date date  =  new Date();
        SimpleDateFormat outFormat = new SimpleDateFormat("yyyy-MM-dd");
        return outFormat.format(date);
    }

    public static String getTimeNow() {
        Date date  =  new Date();
        SimpleDateFormat outFormat = new SimpleDateFormat("HH:mm");
        return outFormat.format(date);
    }

    public static String getMinutesNow() {
        Date date                  =  new Date();
        SimpleDateFormat outFormat = new SimpleDateFormat("mm");
        return outFormat.format(date);
    }


    public static String getMinutesNowPlusFifteen() {

        Calendar now               = Calendar.getInstance();
        now.add(Calendar.SECOND,(-15*60));

        Date date                  =  now.getTime();
        SimpleDateFormat outFormat = new SimpleDateFormat("HH:mm");

        return outFormat.format(date);
    }




    public static String getHourNow() {
        Date date  =  new Date();
        SimpleDateFormat outFormat = new SimpleDateFormat("HH");
        return outFormat.format(date);
    }


    public static String convertDateFormat(String date) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date testDate        = null;
        try {
            testDate = sdf.parse(date);
        }
        catch(Exception ex){
            ex.printStackTrace();
        }
        return sdf.format(testDate);
    }


    public static String convertToNotificationDate(String date) {
        Date parsedDate;
        String result             = "";
        SimpleDateFormat inFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        try {
            parsedDate = inFormat.parse(date);
            SimpleDateFormat outFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
            result     = outFormat.format(parsedDate);
        }
        catch(Exception ex){
            ex.printStackTrace();
        }

        return result;
    }
}
