package com.andreums.culturarocafort.util;

import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.CoreProtocolPNames;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.util.EntityUtils;

import java.io.IOException;

public class Downloader {
        private String url;
        private String result;
        private String eTag;
        private Header[] headers;
    private String URL;

    public Downloader(String url) {
            this.url    = url;
        }


        public String getHeader(String name) {
            String result = "";
            try {
                for (Header header:this.headers) {
                    if (header.getName().equalsIgnoreCase(name)) {
                        result = header.getValue();
                        break;
                    }
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }

            return result;
        }

        public String getResult() {
            return result;
        }

        public String getETag() {
            return eTag;
        }

        public Downloader invoke() {
            int timeoutSocket         = 120000;
            int timeoutConnection     = 120000;

            HttpParams httpParameters = new BasicHttpParams();
            HttpConnectionParams.setConnectionTimeout(httpParameters, timeoutConnection);
            HttpConnectionParams.setSoTimeout(httpParameters, timeoutSocket);

            HttpClient client     = new DefaultHttpClient(httpParameters);
            client.getParams().setParameter(CoreProtocolPNames.USER_AGENT,"Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.7.12) Gecko/20050915 Firefox/1.0.7");
            HttpGet request       = new HttpGet(url);
            HttpResponse response;
            HttpEntity entity;

            try {
                response            = client.execute(request);
                entity              = response.getEntity();
                this.result         = EntityUtils.toString(entity, "UTF-8");


                this.headers    = response.getAllHeaders();
                if (headers.length>0) {
                    for(Header header:this.headers) {
                        if (header.getName().equalsIgnoreCase("etag")) {
                            this.eTag = header.getValue();
                            break;
                        }
                    }
                }
            }
            catch (IOException e) {
                e.printStackTrace();
            }
            finally {
                client.getConnectionManager().shutdown();
            }
            return this;
        }

    public void setURL(String url) {
        this.url = url;
    }

    public String getURL() {
        return this.url;
    }
}
