package com.andreums.culturarocafort.util;

import org.htmlcleaner.HtmlCleaner;
import org.htmlcleaner.HtmlNode;
import org.htmlcleaner.SimpleHtmlSerializer;
import org.htmlcleaner.TagNode;
import org.htmlcleaner.TagNodeVisitor;

/**
 * Created by andreu on 22/01/14.
 */
public class HTML {


    public static String getCleanHTML(String data, int width) {
        HtmlCleaner cleaner     = new HtmlCleaner();
        TagNode node            = cleaner.clean(data);
        width                   = width-130;

        final int finalWidth = width;
        node.traverse(new TagNodeVisitor() {
            public boolean visit(TagNode tagNode, HtmlNode htmlNode) {
                if (htmlNode instanceof TagNode) {
                    TagNode tag = (TagNode) htmlNode;
                    String tagName = tag.getName();
                    if ("img".equals(tagName)) {
                        tag.removeAttribute("class");
                        tag.removeAttribute("style");
                        tag.removeAttribute("width");
                        tag.removeAttribute("height");
                        tag.addAttribute("width",String.valueOf(finalWidth)+"px");
                    }
                    if ("div".equals(tagName)) {
                        tag.removeAttribute("class");
                        tag.removeAttribute("style");
                        tag.removeAttribute("width");
                        tag.removeAttribute("height");
                    }
                }
                return true;
            }
        });

        SimpleHtmlSerializer serializer = new SimpleHtmlSerializer(cleaner.getProperties());
        data                            = serializer.getAsString(node);
        return data;
    }


    public static String getContentsAsHTML(String data,int width) {
        data        = "<html><head> " +
                "   <meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\"> " +
                "   <script type=\"text/javascript\" src=\"file:///android_asset/js/jquery.js\"></script> " +
                "   <script type=\"text/javascript\" src=\"file:///android_asset/js/fitvid.js\"></script> " +
                "   <script type=\"text/javascript\" src=\"file:///android_asset/js/init.js\"></script> " +
                "   <style type=\"text/css\"> img { max-width: 100%; } </style>" +
                "   </head> " +

                "   <body>"+HTML.getCleanHTML(data,width)+"</body>" +
                "   </html>";
        return data;
    }


}