package com.andreums.culturarocafort.util;

import android.content.Context;
import android.content.res.Resources;
import android.util.DisplayMetrics;

import java.util.Locale;

public class LocaleUtil {

    private Context context;

    public LocaleUtil(Context context) {
        this.context = context;
    }

    public void setDefaultLocale(Locale locale) {
        Resources res = this.context.getResources();
        DisplayMetrics dm = res.getDisplayMetrics();
        android.content.res.Configuration conf = res.getConfiguration();
        conf.locale = locale;
        res.updateConfiguration(conf, dm);

        Preferences preferences = Preferences.getInstance(this.context);
        preferences.setValue("locale",locale.getLanguage());
    }

    public String getLocale() {
        String locale  = "";
        String locale1 = "";
        if (locale1.length()==0) {
            Preferences preferences = Preferences.getInstance(this.context);
            locale                  = preferences.getValue("locale");
            if (locale.length()==0) {
                locale = "ca";
            }
            locale1 = locale;
        }
        else {
            locale = locale1;
        }
        return locale;
    }

}
