package com.andreums.culturarocafort.util;

import android.content.Context;
import android.content.SharedPreferences;

public class Preferences {

    private static Preferences instance;
    private Context context;

    private Preferences(Context context) {
        this.context = context;
    }

    public static Preferences getInstance(Context context) {
        if (Preferences.instance==null) {
            Preferences.instance = new Preferences(context);
        }
        return Preferences.instance;
    }

    public void setValue(String key, String value) {
        SharedPreferences prefs = this.context.getSharedPreferences("rocafortApp", Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putString(key,value);
        editor.commit();
    }

    public String getValue(String key) {
        SharedPreferences prefs = this.context.getSharedPreferences("rocafortApp",Context.MODE_PRIVATE);
        return prefs.getString(key,"");
    }


    public boolean getValueBoolean(String key) {
        SharedPreferences prefs = this.context.getSharedPreferences("rocafortApp",Context.MODE_PRIVATE);
        return prefs.getBoolean(key,false);
    }

    public void setValueBoolean(String key, boolean value) {
        SharedPreferences prefs = this.context.getSharedPreferences("rocafortApp", Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putBoolean(key,value);
        editor.commit();
    }

    public int getValueInt(String key) {
        SharedPreferences prefs = this.context.getSharedPreferences("rocafortApp",Context.MODE_PRIVATE);
        return prefs.getInt(key,-1);
    }

    public void setValueInt(String key, int value) {
        SharedPreferences prefs = this.context.getSharedPreferences("rocafortApp", Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putInt(key,value);
        editor.commit();
    }

    public long getValueLong(String key) {
        SharedPreferences prefs = this.context.getSharedPreferences("rocafortApp",Context.MODE_PRIVATE);
        return prefs.getLong(key,-1);
    }

    public void setValueLong(String key, long value) {
        SharedPreferences prefs = this.context.getSharedPreferences("rocafortApp", Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putLong(key,value);
        editor.commit();
    }


    public boolean isFirstRun() {
        String value = this.getValue("firstRun");
        if (value.length()==0) {
            this.setValue("firstRun","true");
            return true;
        }
        return false;
    }

}

