package com.andreums.culturarocafort.util;

import android.content.Context;

import com.andreums.culturarocafort.database.GeocoderDatabaseHandler;
import com.andreums.culturarocafort.models.LatLng;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

public class StaticMaps {


    private String address = "http://maps.googleapis.com/maps/api/staticmap?center=CENTER&zoom=17&size=600x350&sensor=true&markers=color:red|POSITION&visual_refresh=true&scale=4&language=ca";

    public StaticMaps() {}

    public String getURLForImageAtPosition(LatLng position, int width, int height) {
        String latlng = position.latitude()+","+position.longitude();
        String result = this.address.replace("CENTER", latlng).replace("POSITION", latlng);
        result        = result.replace("WIDTH",String.valueOf(width)).replace("HEIGHT",String.valueOf(height));
        return result;
    }

    public static LatLng getLatLongFromAddress(Context context,String address) {
        // TODO: GRAN ERROR NETworkOnMainThreadException!!!!!
        double lat;
        double lng;
        LatLng result;
        String copy   = address;

        GeocoderDatabaseHandler handler = new GeocoderDatabaseHandler(context);
        result                          = handler.getPosition(address);
        if (result.latitude()!=0 && result.longitude()!=0) {
            return result;
        }
        else {
            try {
                address = URLEncoder.encode(address, "UTF-8");
            }
            catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }

            String url            = "http://maps.google.com/maps/api/geocode/json?address=" +address+"&sensor=true";
            Downloader downloader = new Downloader(url);
            downloader.invoke();
            String response       = downloader.getResult();

            JSONObject jsonObject;
            try {
                jsonObject = new JSONObject(response);
                lng        = ((JSONArray)jsonObject.get("results")).getJSONObject(0).getJSONObject("geometry").getJSONObject("location").getDouble("lng");
                lat        = ((JSONArray)jsonObject.get("results")).getJSONObject(0).getJSONObject("geometry").getJSONObject("location").getDouble("lat");

                result     = new LatLng(lat,lng);
            }
            catch (JSONException e) {
                e.printStackTrace();
            }
            handler.insertAddress(copy,result);
        }
        return result;
    }

}
